package com.speedingplanet.banking.api;

import com.fasterxml.jackson.annotation.JsonProperty;

import javax.persistence.*;

@SuppressWarnings("JpaQlInspection")
@Entity
@Table(name = "categories")
@NamedQueries({
    @NamedQuery(
        name = "com.speedingplanet.banking.api.Category.findAll",
        query = "SELECT c from Category c"
    )
})
public class Category {
  public Category() {}

  public Category(int categoryId, String categoryName) {
    this.categoryId = categoryId;
    this.categoryName = categoryName;
  }

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int categoryId;

  @Column(name = "categoryName", nullable = false)
  private String categoryName;

  public int getCategoryId() {
    return categoryId;
  }

  public String getCategoryName() {
    return categoryName;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (!(o instanceof Category)) return false;

    Category category = (Category) o;

    if (categoryId != category.categoryId) return false;
    return categoryName.equals(category.categoryName);

  }

  @Override
  public int hashCode() {
    int result = categoryId;
    result = 31 * result + categoryName.hashCode();
    return result;
  }
}
