package com.speedingplanet.banking.api;

import com.fasterxml.jackson.annotation.JsonProperty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

@SuppressWarnings("JpaQlInspection")
@Entity
@Table(name = "payees")
@NamedQueries({
    @NamedQuery(
        name = "com.speedingplanet.banking.api.Payee.findAll",
        query = "SELECT py from Payee py"
    )
})
public class Payee {
  public Payee() {}

  public Payee(int payeeId, String payee) {
    this.payeeId = payeeId;
    this.payee = payee;
  }

  public Payee(int payeeId, String payee, int categoryId, String address, String city, String state, String zip, String image, String motto) {
    this.payeeId = payeeId;
    this.payee = payee;
    this.categoryId = categoryId;
    this.address = address;
    this.city = city;
    this.state = state;
    this.zip = zip;
    this.image = image;
    this.motto = motto;
  }

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int payeeId;

  @NotNull
  private String payee;

  @NotNull
  private int categoryId;

  @NotNull
  private String address;

  @NotNull
  private String city;

  @NotNull
  private String state;

  @NotNull
  private String zip;

  @Column(nullable = true)
  private String image;

  @Column(nullable = true)
  private String motto;

  public int getPayeeId() {
    return payeeId;
  }

  public String getPayee() {
    return payee;
  }

  public int getCategoryId() {
    return categoryId;
  }

  public String getAddress() {
    return address;
  }

  public String getCity() {
    return city;
  }

  public String getState() {
    return state;
  }

  public String getZip() {
    return zip;
  }

  public String getImage() {
    return image;
  }

  public String getMotto() {
    return motto;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (!(o instanceof Payee)) return false;

    Payee payee1 = (Payee) o;

    if (payeeId != payee1.payeeId) return false;
    if (categoryId != payee1.categoryId) return false;
    if (!payee.equals(payee1.payee)) return false;
    if (!address.equals(payee1.address)) return false;
    if (!city.equals(payee1.city)) return false;
    if (!state.equals(payee1.state)) return false;
    if (!zip.equals(payee1.zip)) return false;
    if (image != null ? !image.equals(payee1.image) : payee1.image != null) return false;
    return motto != null ? motto.equals(payee1.motto) : payee1.motto == null;

  }

  @Override
  public int hashCode() {
    int result = payeeId;
    result = 31 * result + payee.hashCode();
    result = 31 * result + categoryId;
    result = 31 * result + state.hashCode();
    result = 31 * result + zip.hashCode();
    return result;
  }
}
