package com.speedingplanet.banking.db;

import com.speedingplanet.banking.api.Category;
import io.dropwizard.hibernate.AbstractDAO;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;

import java.util.List;

public class CategoryDAO extends AbstractDAO<Category> {

  public CategoryDAO(SessionFactory sessionFactory) {
    super(sessionFactory);
  }

  public Category findById(Integer id) {
    return get(id);
  }

  public List<Category> findAll() {
    return list(namedQuery("com.speedingplanet.banking.api.Category.findAll"));
  }

  public List<Category> query(String categoryName, Integer categoryId) {
    Criteria c = criteria();
    if (categoryId != null && categoryId > 0) {
      c.add(Restrictions.eq("categoryId", categoryId));
    } else {
      if (!categoryName.isEmpty()) {
        c.add(Restrictions.ilike("categoryName", "%" + categoryName + "%"));
      }
    }
    return list(c);
  }

}
